var widgetAPI = new Common.API.Widget();
var pluginAPI = new Common.API.Plugin();
var tvKey = new Common.API.TVKeyValue();

var Main = {
    cnt_for_buffer: 0,
    screen_position_h: 0,
    screen_position_w: 0,
    scr_timeout: 120,
    sleep: 1,
    count_time: 0,
    sc_deltay: 5,
    sc_deltax: 4,
    first_down: 0,
    selectedVideo: 0,
    mode: 0,
    mute: 0,
    val: '',
    login: '',
    guest: '',
    logged: 0,
    error: 0,
    list: 0,
    username: '',
    username_dec: '',
    pass: '',
    product: '',
    UP : 0,
    DOWN : 1,
    loading: 0,
    WINDOW: 0,
    FULLSCREEN: 1,
    NMUTE: 0,
    YMUTE: 1,
    logged_in: 0,
    second_page: 0,
};

setScreenTime = function() {
	// Set screensaver out time to 10 sec - for testing.
	alert("[APPS] ----- Set screensaver timeout 10 seconds")
	pluginAPI.setOnScreenSaver(10);	
};

Main.initKeys = function() {
 var nnaviPlugin = document.getElementById("pluginObjectNNavi");
  nnaviPlugin.SetBannerState(2);
  pluginAPI.unregistKey(tvKey.KEY_VOL_UP);
  pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);
  pluginAPI.unregistKey(tvKey.KEY_MUTE);
   pluginAPI.unregistKey(tvKey.KEY_MENU);
  pluginAPI.unregistKey(tvKey.KEY_INFOLINK);
  
  pluginAPI.unregistKey(tvKey.KEY_CONTENT);
  
 // for media player bug
 
    pluginAPI.registKey(tvKey.KEY_SOURCE);
 
}



Main.onLoad = function() {
window.onShow = Main.initKeys();
 Main.loading=1;
 //Display.openPopup('network');
 Network.init();
 
  $('#progressBar').width(0);
  setTimeout(pluginAPI.setOffScreenSaver, 10000);
    if (!Main.interval_name) {
        Main.interval_name = setInterval(SetScreensaver, Main.sleep*1000);
    }
    if (Player.init() && Audio.init() && Display.init() && Server.init() && Network.init()) {
    //if (Player.init()  && Display.init() && Server.init() && Network.init()) {
      Audio.cannot_be_controlled();
       this.enableKeys();
     Network.CheckPhysicalConnection();
     if(Network.error)
    return;
     Main.interval_network = setInterval(Network.CheckPhysicalConnection, 10000);
    //mute1=Audio.plugin.GetSystemMute();
   // mute2=Audio.plugin.GetUserMute() ;
    //Server.dolog(Main.username_dec, 'MUTE', mute1,mute2);
    // if(Audio.plugin.GetSystemMute() == 1  || Audio.plugin.GetUserMute()  == 1 ) {
     if(Audio.plugin.GetUserMute()  == 1 ) {
      //Server.dolog(Main.username_dec, 'TEST', 'MUTE',"");
       $('#volumeIcon').css('backgroundPosition', '-100px 0px');
       this.mute = this.YMUTE;
      } else {
        this.mute = this.NMUTE;
       var volume = Audio.getVolume();
       Display.setVolume(volume);
       //Server.dolog(Main.username_dec, 'TEST', 'NOT MUTE',"");
      }
       //this. muteMode();
        Display.setTime(0);
        Player.stopCallback = function() {
           Main.setWindowMode();
        }
          widgetAPI.sendReadyEvent();    
        // Prima pagina
        action_on_file(0, 0);
        Main.username_dec=Main.guest;
        if (Main.guest) {
            Main.username_dec = Main.guest;
        } else {
            Main.username_dec = decode64(Main.username);
        }
        //Main.username_dec="drivecast_user";
         //$('#user').text(Main.username_dec); // DOESN'T WORK!!!
        document.getElementById('user').innerHTML = Main.username_dec;
        if (Main.username == '' && Main.logged_in == 0 && !this.error && Main.guest == '') {
            alert('First login');
            alert('No login defined');
            Display.showLogin();
            Server.get_keypair();
            Main.second_page = 1;
            return;
        }
          Server.fetchVideoList(); 
         
    } else {
        alert('Failed to initialise');
    }
};

Main.onUnload = function() {
pluginAPI.unregistKey(tvKey.KEY_SOURCE);
 clearInterval(Main.interval_network);
   if (Player.state == Player.PLAYING || Player.state == Player.PAUSED) {
       Player.stopVideo();
    }
    Player.deinit();
    pluginAPI.setOnScreenSaver();
    clearInterval(Main.move_screen_interval);
    clearInterval(Main.interval_name);
};

Main.updateCurrentVideo = function(move) {
    var tot = Data.getVideoCount() ;
    var sel = this.selectedVideo + 1;
   $('#progressBar').width(0);
    Player.setVideoURL(Data.getVideoURL(this.selectedVideo));
    Display.setVideoListPosition(this.selectedVideo, move);
    Display.setDescription(Data.getVideoDescription(this.selectedVideo));
    if (sel == tot) {
        $('#next').css('opacity', 0.4);
    }
    if (sel == 1) {
        $('#previous').css('opacity', 0.4);
    }
};

Main.enableKeys = function() {
    $('#anchor').focus();
};

Main.resetList = function() {
    Main.selectedVideo = 0;
    Display.FIRSTIDX = 0;
    Display.LASTIDX = 4;
    Display.currentWindow = 0;
    Display.SELECTOR = 0;
    Display.LIST = 1;
    $('#itemThumbnail img').attr('src', '');
    $('#itemThumbnail').hide();
    $('#videoList').css('top', 0);
};

Main.keyDown = function(key) {
    keyCode = key || event.keyCode;
    //if(key == undefined) {
    //Server.dolog(Main.username_dec, 'TEST1', 'TEST1',keyCode);
    // widgetAPI.blockNavigation(event);
     //alert("Blocking navigation event");
    //}
    
  //  Server.dolog(Main.username_dec, 'TEST', 'TEST',keyCode);
     Main.count_time = 0;
    clearInterval(Main.move_screen_interval);
    clearInterval(Main.interval_name);
    Main.interval_name = setInterval(SetScreensaver, Main.sleep * 1000);
     if ($('#screensaver').is(':visible')) {
        $('#bubble').hide();
        $('#screensaver').hide();
        alert('Screensaver OFF');
       } else if ($('#popup').is(':visible')) {
          alert('Key disabled because popup is visible');
          switch (keyCode) {
           case tvKey.KEY_RETURN:
           alert('RETURN');
           widgetAPI.blockNavigation(event);
           Display.closePopup();
            break;
            case tvKey.KEY_ENTER:
            case tvKey.KEY_PANEL_ENTER:
                Display.closePopup();
                if(Network.error) {
                  alert('EXIT');
                  widgetAPI.sendExitEvent();
                }
                break;
            case tvKey.KEY_EXIT:
               Display.closePopup();
                widgetAPI.sendExitEvent();
                break;
             case tvKey.KEY_INFOLINK:
              alert("INTERNET");
              widgetAPI.sendExitEvent();
               break;
            default:
                //widgetAPI.blockNavigation();
                alert('Navigation disabled');
        }
    } else {
       if(Main.loading == 1) {
         widgetAPI.blockNavigation(event);
         alert('Key disabled because loading in progress');
         return;
        }
        alert('Key pressed: ' + keyCode);
        switch (keyCode) {
            case tvKey.KEY_INFOLINK:
              alert("INTERNET");
              widgetAPI.sendExitEvent();
               break;
            case tvKey.KEY_RETURN:
            //case tvKey.KEY_PANEL_RETURN:
             widgetAPI.blockNavigation(event);
             alert("RETURN");
              var state=Player.state;
                  if (Main.error == 0) {
                    Player.stopVideo();
                }
                 if(state == 0) {
                  if(Main.guest) {
                  if (Main.second_page == 0) 
                    Main.second_page = 1;
                    this.logged=0;
                    Main.guest=0;
                    Main.get_command=0;
                   $('#login_loading').show();
                   Server.get_username(1);
                   alert("Trying to pairing manually");
                 }else {
                   alert("EXIT");
                   widgetAPI.sendReturnEvent(); 
                  }
                }
                break;
            // YELOW GUEST
            case tvKey.KEY_YELLOW:
                if (this.logged || this.error) {
                    break;
                }
                if (Main.second_page == 0) {
                    Main.second_page = 1;
                    //break;
                }
                //this.logged=0;
                Main.loading=1;
                $('#login_loading').show();
                Server.get_username(1);
                alert("Trying to pairing manually");
                break;
                case tvKey.KEY_EXIT:
                 widgetAPI.sendExitEvent();
                 break;
                case tvKey.KEY_BLUE:
                 if (this.mode == this.FULLSCREEN || Player.state != Player.STOPPED || Main.second_page == 1) {
                    break;
                }
                 Main.loading=1;
                delete_element();
                break;
            case tvKey.KEY_RED:
             Data.videoURLs=[];
              if(Main.loading == 1)
             break;
             Main.loading=1;
                   if (this.logged == 0 && this.error != 1) {
                    //$("#delete").hide();
                    Main.guest = GUEST_USER;
                    Main.login = GUEST_USER;
                    Main.username_dec = GUEST_USER;
                    document.getElementById('user').innerHTML = Main.login;
                    action_on_file(1, 0);
                    this.list = 0;
                    Server.fetchVideoList();
                    this.logged = 1;
                    $('#logout').css('display', 'inline-block');
                    Main.second_page = 0;
                    break;
                }
                $('#next').css('opacity', 0.4);
                $('#previous').css('opacity', 0.4);
                Player.stopVideo();
                Main.guest = '';
                // PAIRING
                if (Main.second_page) {
                    this.list=0;
                    Display.showLogin();
                    Server.get_keypair();
                    Main.second_page = 0;
                    break;
                }
                //  ERRORE
                if (this.error == 1) {
                    action_on_file(1, 0);
                    Main.list = 0;
                    Main.error = 0;
                    Main.login = '';
                    Main.second_page = 1;
                    Display.showLogin();
                    Server.get_keypair();
                    alert('Error');
                    break;
                }
                //  LOGOUT
                if (this.logged == 1) {
                   Main.get_command=0;
                    Main.id_channel=0;
                     this.logged = 0;
                    $('#logout').hide();
                    Main.error = 0;
                    Main.login = '';
                    Main.username="";
                    Main.guest=0;
                    Main.username_dec="";
                    action_on_file(1, 0);
                    Main.get_command=0;
                    this.list = 0;
                    Main.resetList();
                    Main.second_page = 1;
                    Display.showLogin();
                    Server.get_keypair();
                    alert("Logout");
                    break;
                }
                // AUTH
                Server.get_username();
                break;
            //RELOAD
            case tvKey.KEY_GREEN:
                if (this.mode == this.FULLSCREEN || Player.state != Player.STOPPED) {
                    break;
                }
                Player.stopVideo();
                $('#next').css('opacity', 0.4);
                $('#previous').css('opacity', 0.4);
                if (this.list == 0) {
                    break;
                }
                this.login = this.val;
                Main.resetList();
                Main.loading=1;
                $('#videoCount').text(LOADING);
                $('#listLoading').show();
                Server.fetchVideoList(); 
                break;
                
            case tvKey.KEY_LEFT: 
                break;
            case tvKey.KEY_RIGHT: 
                break;
                
            case tvKey.KEY_PLAY:
            if(Main.loading || Player.state == 1 || Player.skipState == 3 || Player.skipState == 4 || Main.second_page == 1 ||  Data.getVideoCount() == 0)
              break;
                Main.interval_buffer = setInterval(Player.count_waiting_buffer, 1000);
                alert('PLAY');
                this.handlePlayKey();
                break;
            case tvKey.KEY_STOP:
                if (Main.error == 1) {
                    break;
                }
                alert('STOP');
                if (Data.videoPosition) {
                    Data.videoPosition[Main.selectedVideo] = 0;
                }
               Player.stopVideo();
                break;
            case tvKey.KEY_PAUSE:
            if(Player.stop_cmd)
              break;
             /*
               if(Player.state != 1 || Player.skipState == 3 || Player.skipState == 4)
                return;
                alert('PAUSE');
                Player.state=2;
                */
                 Player.pauseVideo();
                break;
            case tvKey.KEY_FF:
              if(Player.state != 1 || Player.stop_cmd == 1)
                break;
                alert('FF');
                 Player.skipForwardVideo();
                  break;
            case tvKey.KEY_RW:
                if(Player.state != 1 || Player.stop_cmd == 1)
                 break;
                alert('RW');
                Player.skipBackwardVideo();
               break;
              case tvKey.KEY_VOL_UP:
             case tvKey.KEY_PANEL_VOL_UP:
               if(Audio.cannot_be_controlled())
                 break;
                Main.noMuteMode();
                alert('VOL_UP');
                if (this.mute == 0) {
                    Audio.setRelativeVolume(0);
                }
                break;
                
            case tvKey.KEY_VOL_DOWN:
            case tvKey.KEY_PANEL_VOL_DOWN:
                if(Audio.cannot_be_controlled())
                 break;
                Main.noMuteMode();
                alert('VOL_DOWN');
                if (this.mute == 0) {
                    Audio.setRelativeVolume(1);
                }
                break;
              
            case tvKey.KEY_DOWN:
              if (Main.loading == 1|| Main.error == 1 || Main.mode == this.FULLSCREEN || Data.getVideoCount() == 0 ) {
                    break;
               }
                 alert('DOWN');
                 this.selectNextVideo(this.DOWN);
                break;
            case tvKey.KEY_UP:
               if (Main.loading == 1 || Main.error == 1  || Main.mode == this.FULLSCREEN || Data.getVideoCount() == 0) {
                    break;
                }
                
                 alert('UP');
               this.selectPreviousVideo(this.UP);
                break;
            case tvKey.KEY_MUTE:
            
              if(Audio.cannot_be_controlled())
                 break;
                 alert('MUTE');
                 this.muteMode();
                 break;
            case tvKey.KEY_SOURCE:
             break;
            case tvKey.KEY_ENTER:
            case tvKey.KEY_PANEL_ENTER:
               if (Main.loading || this.logged == 0  || Player.skipState == 3 || Player.skipState == 4 || Data.getVideoCount() == 0) 
                   break;
                 if(Player.state == 1 && Player.stop_cmd)
                   break;
                 if((Player.state == 1 || Player.state ==2) && Data.videoType[Main.selectedVideo] == 'video') {
                   alert('ENTER');
                  this.toggleMode();
                    break;
                 }
                 if (Player.state != 1) { 
                    Main.interval_buffer = setInterval(Player.count_waiting_buffer, 1000);
                    alert('PLAY');
                    this.handlePlayKey();
                    break;
                }
                 break;
              default:
              // Server.dolog(Main.username_dec, 'TEST2', 'TEST2',keyCode);
                alert('Unhandled key');
        }
    }
};

Main.handlePlayKey = function() {
   switch (Player.getState()) {
        case Player.STOPPED:
            Player.stop_cmd=1;
            Player.playVideo();
            break;
        case Player.PAUSED:
           Player.stop_cmd=0;
            Player.resumeVideo();
            break;
        default:
            alert('Ignoring play key, not in correct state');
            break;
    }
};

Main.handlePauseKey = function() {
  switch (Player.getState()) {
        case Player.PLAYING:
            Player.pauseVideo();
            break;
        default:
            alert('Ignoring pause key, not in correct state');
            break;
    }
};

Main.selectNextVideo = function(down) {
   Player.stopVideo();
    if ((this.selectedVideo + 1) == Data.getVideoCount()) {
        return;
    }
    this.selectedVideo = (this.selectedVideo + 1) % Data.getVideoCount();
    this.updateCurrentVideo(down);
};

Main.selectPreviousVideo = function(up) {
  Player.stopVideo();
    if (this.selectedVideo == 0) {
        return;
    }
    if (--this.selectedVideo < 0) {
        this.selectedVideo += Data.getVideoCount();
    }
    this.updateCurrentVideo(up);
};

Main.setFullScreenMode = function() {
   if (this.mode != this.FULLSCREEN) {
        Display.hide();
        Player.setFullscreen();
         this.mode = this.FULLSCREEN;
    }
};

Main.setWindowMode = function() {
    if (this.mode != this.WINDOW) {
        Display.show();
        Player.setWindow();
        this.mode = this.WINDOW;
    }
};

Main.toggleMode = function() {
   switch (this.mode) {
        case this.WINDOW:
            this.setFullScreenMode();
             break;
        case this.FULLSCREEN:
            this.setWindowMode();
            break;
        default:
            alert('ERROR: unexpected mode in toggleMode');
            break;
    }
};

Main.muteMode = function() {
    switch (this.mute) {
        case this.NMUTE:
            this.setMuteMode();
            break;
        case this.YMUTE:
            this.noMuteMode();
            break;
        default:
            alert('ERROR: unexpected mode in muteMode');
            break;
    }
};

Main.setMuteMode = function() {
    if (this.mute != this.YMUTE) {
        Audio.plugin.SetSystemMute(true);
        Audio.plugin.SetUserMute(true); 
        $('#volumeIcon').css('backgroundPosition', '-100px 0px');
        this.mute = this.YMUTE;
    }
};

Main.noMuteMode = function() {
    if (this.mute != this.NMUTE) {
        Audio.plugin.SetSystemMute(false); 
        Audio.plugin.SetUserMute(false); 
        $('#volumeIcon').css('backgroundPosition', '-120px 0px');
        Display.setVolume( Audio.getVolume() );
        this.mute = this.NMUTE;
    }
};


Main.itemLoading =function () {
 if(this.mode == this.FULLSCREEN && Data.videoType[Main.selectedVideo] == 'video')
     $('#itemLoading_video').show();
    else
      $('#itemLoading').show();
};

Main.itemLoadingHide =function () {
if(this.mode == this.FULLSCREEN && Data.videoType[Main.selectedVideo] == 'video')
     $('#itemLoading_video').hide();
  else
      $('#itemLoading').hide();
};


action_on_file = function (write,el) {
    var fileSystemObj = new FileSystem();
    if (fileSystemObj.isValidCommonPath(curWidget.id) == 0) {
        fileSystemObj.createCommonDir(curWidget.id);
    }
    if(write) {
        var jsFileObj = fileSystemObj.openCommonFile(curWidget.id + '/credentials.dat', 'w');
        jsFileObj.writeLine('');
        fileSystemObj.closeCommonFile(jsFileObj);
    } else {
        if (fileSystemObj.isValidCommonPath(curWidget.id + '/credentials.dat')) {
            var jsFileObj = fileSystemObj.openCommonFile(curWidget.id + '/credentials.dat', 'r');
            Main.username = jsFileObj.readLine();
            Main.pass = jsFileObj.readLine();
            fileSystemObj.closeCommonFile(jsFileObj);
        }
    }
    return 0;
};

get_language = function () {
    var vars = window.location.search;
  	if (vars.charAt(0) == '?') {
		vars = vars.slice(1, vars.length);
	}
   	vars = vars.split('&');
    for (var i = 0; i < vars.length; i++) {
        var data = vars[i].split('=');
        if (data[0] == 'lang') {
            var language = data[1];
        }
        if (data[0] == 'product') {
            var product = data[1];
        }
    }
    switch (product) {
        case 0:
            Main.product = 'SamsungTV';
            break;
        case 1:
            Main.product = 'SamsungMonitor';
            break;
        case 2:
            Main.product = 'SamsungBlueray';
            break;
        default:
            Main.product = 'SamsungEmulator';
    }
    var file_language = 'en.js';
    if (language == 'it') {
        file_language = 'it.js';
    }
   document.write('<script language="javascript" type="text/javascript" src="Language/' + file_language + '">');
};

function decode64(input) {
    var output = '';
    var hex = '';
    var chr1, chr2, chr3 = '';
    var enc1, enc2, enc3, enc4 = '';
    var i = 0;
    
    var b64array = 'ABCDEFGHIJKLMNOP' +
        'QRSTUVWXYZabcdef' +
        'ghijklmnopqrstuv' +
        'wxyz0123456789+/' +
        '=';
    var base64test = /[^A-Za-z0-9\+\/\=]/g;
    if (base64test.exec(input)) {
        alert('There were invalid base64 characters in the input text.\n' +
            'Valid base64 characters are A-Z, a-z, 0-9, "+", "/",and "="\n' +
            'Expect errors in decoding.');
    }
    input = input.replace(/[^A-Za-z0-9\+\/\=]/g, '');
    do {
        enc1 = b64array.indexOf(input.charAt(i++));
        enc2 = b64array.indexOf(input.charAt(i++));
        enc3 = b64array.indexOf(input.charAt(i++));
        enc4 = b64array.indexOf(input.charAt(i++));
        
        chr1 = (enc1 << 2) | (enc2 >> 4);
        chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
        chr3 = ((enc3 & 3) << 6) | enc4;
        
        output = output + String.fromCharCode(chr1);
        
        if (enc3 != 64) {
            output = output + String.fromCharCode(chr2);
        }
        if (enc4 != 64) {
            output = output + String.fromCharCode(chr3);
        }
    
        chr1 = chr2 = chr3 = '';
        enc1 = enc2 = enc3 = enc4 = '';
    
    } while (i < input.length);
    return output.split(':', 1);
};

function SetScreensaver () {
    Main.count_time = Main.count_time + Main.sleep;
   
    if (Main.count_time >= (Main.scr_timeout)) {
       if (Data.videoType[Main.selectedVideo] && Data.videoType[Main.selectedVideo] == "video" && Player.state == Player.PLAYING)
         return;
        alert("Start screen saver");
        clearInterval(Main.interval_name);
        if (Data.videoThumbnail[Main.selectedVideo] && Main.logged == 1 && Player.state == Player.PLAYING) {
            $('#bubble_logo').attr('src', Data.videoThumbnail[Main.selectedVideo]);
        } else {
            $('#bubble_logo').attr('src', 'Images/dc_logo.png');
        }
        $('#screensaver').show();
        Main.move_screen_interval = setInterval(move_screensaver, 2000);
    }
}

function move_screensaver () {
    /*
    if (Main.sc_deltay > 0) {
        if (Main.screen_position_h + 200 >= 540) {
            Main.sc_deltay = -Main.sc_deltay;
        }
    } else {
        if (Main.screen_position_h == 0) {
            Main.sc_deltay = -Main.sc_deltay;
        }
    }
    Main.screen_position_h = Main.screen_position_h + Main.sc_deltay;
    if (Main.sc_deltax > 0) {
        if (Main.screen_position_w + 200 >= 960) {
            Main.sc_deltax = -Main.sc_deltax;
        }
    } else {
        if (Main.screen_position_w == 0) {
            Main.sc_deltax = -Main.sc_deltax;
        }
    }
    Main.screen_position_w = Main.screen_position_w + Main.sc_deltax;
    $('#bubble').css({
        top: Main.screen_position_h,
        left: Main.screen_position_w
    });
    */
    if ($('#bubble').is(':hidden')) {
        $('#bubble').css({
            top: 340 * Math.random(),
            left: 760 * Math.random()
        }).show();
    } else {
        $('#bubble').hide();
    }
}

function delete_element () {
    if (Main.username && Data.videoURLs && Data.videoURLs[Main.selectedVideo] && $('#listLoading').is(':hidden')) {
         alert("Deleting element");
        this.login = this.val;
        $('#videoList').empty();
        $('#description').empty();
        $('#videoCount').text(DELETING_EL);
        $('#delete_element').hide();
        $('#listLoading').show();
        Server.dolog(Main.username_dec, 'DELETE', Data.videoURLs[Main.selectedVideo], Data.videoSource[Main.selectedVideo]);
    } else
      Main.loading=0;
   };


